using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
	}
	
	protected void btnSubmit_Click(object sender, EventArgs e)
	{
		//To update the page with the editor,
		//call this function and pass a reference to the RadEditor control
		SaveInCurrentFile(RadEditor1);
	}
	
	private bool _contentUpdated = false;
	private string _editorContent = string.Empty;
	
	private string EditorMatchEvaluator(Match m)
	{
		_contentUpdated = true;
		string newContent = m.Groups[1].Value+_editorContent+"</content>";
		return newContent;
	}
	
	private void SaveInCurrentFile(RadEditor editor)
	{
		try
		{
			//read file
			string physicalFileName = MapPathSecure(this.AppRelativeVirtualPath);
			FileStream fs = new FileStream(physicalFileName, FileMode.Open, FileAccess.ReadWrite, FileShare.ReadWrite);
			StreamReader sr = new StreamReader(fs);
			string pageContent = sr.ReadToEnd();
			
			//update content
			_contentUpdated = false;
			_editorContent = editor.Content;
			MatchEvaluator mEvaluator = new MatchEvaluator(EditorMatchEvaluator);
			pageContent = Regex.Replace(pageContent, "(<(\\w+):RadEditor[^>]+?ID\\s*=\\s*['\"]?" + editor.ID + "['\"]?[^>]*>[\\s\\S]*?<content>)[\\s\\S]*?</content>", mEvaluator, RegexOptions.IgnoreCase | RegexOptions.Compiled);

			//update file
			if (_contentUpdated)
			{
				fs.Seek(0, SeekOrigin.Begin);
				StreamWriter sw = new StreamWriter(fs);
				sw.BaseStream.SetLength(0);
				sw.Write(pageContent);
				sw.Flush();
				sw.Close();
			}
			else
			{
				sr.Close();
			}
		}
		catch (Exception)
		{
			//"The File Encoding you have provided is not supported!"
			//"Refresh the screen and try again!"
			//"Another process or user is using the resource (ascx/aspx file) you are trying to update."
			//"Check if the ASPNET user (IIS5) / NETWORK SERVICE account (IIS6) has write privileges for this file."
		}
	}
}